#include <windows.h>

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

#include "vars.h"

//
// Create a vars_t array
//

vars_t* vars(unsigned int count, ...)
{
    va_list args;
    unsigned int i;

    vars_t* vars = (vars_t*) vars_alloc(sizeof(vars_t) + count*sizeof(struct var));

    if (vars == NULL) {
        printf("Error allocating memory for the vars[] array\n");
        exit(1);
    }

    vars->count = count;

    // Store the variable addresses and names in the vars[] array

    va_start(args, count);
    
    for (i = 0; i < count; i++) {
        vars->var[i].addr = va_arg(args, void*);
        vars->var[i].name = va_arg(args, char*);
    }

    va_end(args);

    return vars;
}
