//
// Array of variable names and addresses
//

typedef struct {
    unsigned int count;
    struct var {
        void* addr;
        char* name;
    } var[1];
} vars_t;

// Creates a vars_t array
vars_t* vars(unsigned int count, ...);

// We allocate and free the variables with the Win32 heap functions instead of
// malloc because we need to allocate and free them in different modules. If
// we're compiling with /MT each module gets its own heap and this doesn't
// work.

#define vars_alloc(bytes) HeapAlloc(GetProcessHeap(), 0, bytes)
#define vars_free(vars) HeapFree(GetProcessHeap(), 0, vars)
